//
//  FilesOperation.cpp
//  egg
//
//  Created by Yingfeng Wang on 1/23/15.
//  Copyright (c) 2015 Yingfeng Wang. All rights reserved.
//

#include "FilesOperation.h"

bool FilesOperation::PatternMatch(const string &sCurrentFileName, const string &sPattern)
{
    bool bMatchResults = false;
    
    if ((sCurrentFileName.compare(".") != 0) && (sCurrentFileName.compare("..") != 0)
        && (sCurrentFileName.compare("lost+found") != 0) && (sCurrentFileName.length() >= sPattern.length()))
    {
        if ((sPattern == "") || (sPattern == "*"))
            bMatchResults = true;
        else if (sCurrentFileName.compare((sCurrentFileName.length() - sPattern.length()), sPattern.length(), sPattern) == 0)
            bMatchResults = true;
    }
    
    return bMatchResults;
}

vector<string> FilesOperation::LocateFilesWithPattern(const string & sDirector, const string & sPattern)
//sDirector: the directory for search
//sPattern: search pattern
//return the list of file names which match the pattern
{
    DIR *pCurrentDir;
    struct dirent * pDirEntry;
    string sCurrentFileName;
    vector <string> vsFileNames;
    
    pCurrentDir = opendir(sDirector.c_str());
    if (pCurrentDir)
    {
        pDirEntry = readdir(pCurrentDir);
        while (pDirEntry != nullptr)
        {
            sCurrentFileName = string(pDirEntry->d_name);
            if (PatternMatch(sCurrentFileName, sPattern))
                vsFileNames.push_back(sDirector + sCurrentFileName);
            pDirEntry = readdir(pCurrentDir);
        }
        closedir(pCurrentDir);
    }
    
    return vsFileNames;
}