//
//  GraphGrammar.cpp
//  egg
//
//  Created by Yingfeng Wang on 1/25/15.
//  Copyright (c) 2015 Yingfeng Wang. All rights reserved.
//

#include "GraphGrammar.h"

GraphGrammar::GraphGrammar()
{
    
}

GraphGrammar::GraphGrammar(const GraphGrammar &oriGraphGrammar)
//oriGraphGrammar: original graph grammar used as source
{
    size_t i;
    Production *pCurrentProduction;
    
    vpProductions.clear();
    for (i = 0; i < oriGraphGrammar.vpProductions.size(); i++)
    {
        pCurrentProduction = new Production (*(oriGraphGrammar.vpProductions.at(i)));
        vpProductions.push_back(pCurrentProduction);
    }
}

GraphGrammar::~GraphGrammar()
{
    size_t i;
    for (i=0; i<vpProductions.size(); i++)
    {
        delete vpProductions.at(i);
        vpProductions.at(i) = nullptr;
    }
}

void GraphGrammar::AddAnnotation(const string &sNewAnnotation)
//sNewAnnotation: new annotations added to the grammar

{
    vector<Production *>::iterator itpProduction;
    bool bInitialProduction;
    vector<GML *>::iterator itpGML;
    vector<Edge *>::iterator itpEdge;
    
    for (itpProduction = vpProductions.begin(); itpProduction != vpProductions.end(); ++itpProduction)
    {
        bInitialProduction = (*itpProduction)->IsInitial(true); // bPartialParse = true
        if (bInitialProduction)
            for(itpGML=(*itpProduction)->vpRightHandSide.begin();itpGML!=(*itpProduction)->vpRightHandSide.end();++itpGML)
            {
                for (itpEdge = (*itpGML)->vpEdges.begin(); itpEdge != (*itpGML)->vpEdges.end(); ++itpEdge)
                {
                    if (((*itpEdge)->iSource >= 0) && ((*itpEdge)->iTarget >= 0))
                    {
                        (*itpEdge)->sLabel = sNewAnnotation + "|" + (*itpEdge)->sLabel;
                        break;
                    }
                }
            }
    }
}



