//
//  ReadInputGraphs.h
//  egg
//
//  Created by Yingfeng Wang on 1/24/15.
//  Copyright (c) 2015 Yingfeng Wang. All rights reserved.
//

#ifndef __egg__ReadInputGraphs__
#define __egg__ReadInputGraphs__

#include <stdio.h>
#include <fstream>

#include "RegularGraph.h"
#include "Production.h"
#include "ReadGML.h"

using namespace std;

class ReadInputGraphs: public ReadGML
{
    //Parse the current regular graph file
    void ParseRegularGraphFile(const string & sCurrentRegGraphInputFilePath, vector<RegularGraph *> & vpRegG);
    //Parse the current regular graph file as file strem
    void ParseRegularGraphs(ifstream & currentGraphFile_stream, vector<RegularGraph *> & vpRegG);
    //parse a vector of strings representing subgraphs
    void ParseCurrentRegularGraph(vector <string> & vsCurrentSubgraphs, vector<RegularGraph *> & vpRegG);
    //extract regular graph information
    void ExtractRegularGraphInfo(RegularGraph * pRegG, const string & sGraph,
                                 const vector< pair <string, string> > & vpssRegularGraphContent);
public:
    // parse all input graph files
    void ParseAllInputGraphFiles(const vector<string> & vsGraphFilePaths, vector< vector< RegularGraph *> > & vvpRegGraphs);
};


#endif /* defined(__egg__ReadInputGraphs__) */
