//
//  MidasCore.h
//  midas_cpp
//
//  Created by Yingfeng Wang on 3/13/16.
//  Copyright (c) 2016 Yingfeng Wang. All rights reserved.
//

#ifndef __midas_cpp__MidasCore__
#define __midas_cpp__MidasCore__

#include <stdio.h>
#include <map>
#include <boost/filesystem.hpp>
#include <boost/algorithm/string.hpp>

#include "ParseConfigure.h"
#include "Database.h"
#include "ParseSpectraFile.h"
#include "SpectrumUnit.h"

#define MAXNUMSPECTRA 300
#define PROTONMASS    1.007825
#define HIGHESTRANK   5

using namespace std;

class MidasCore
{
    SettingInfo *pSettingInfo;
    const char cPathSeparator =       // path separator
                                #ifdef _WIN32
                                '\\';
                                #else
                                '/';
                                #endif
    //intialize member variables according to input arguments
    void InitializeArguments(const map<string, string> & mArguments);
    //if the path of folder doesn't end with a path separator, add the separator to the end
    string AddPathSeparator(const string & sPath);
    void ClearSpectraVector(vector<SpectrumUnit *> & vpSpectra);//clear the vector storing spectra
    void OutputHead(); //output results files head under official mode
    void OutputResults(const vector<SpectrumUnit *> &vpSpectra);// output results;
    void OutputResults_internal(const vector<SpectrumUnit *> &vpSpectra);//output results under internal mode
    void OutputResults_official(const vector<SpectrumUnit *> &vpSpectra);//output results under official mode
    
public:
    MidasCore();
    MidasCore(map<string, string> mArguments);
    ~MidasCore();
    void Process(); //process all spectra
};

#endif /* defined(__midas_cpp__MidasCore__) */
