//
//  SettingInfo.cpp
//  midas_cpp
//
//  Created by Yingfeng Wang on 3/13/16.
//  Copyright (c) 2016 Yingfeng Wang. All rights reserved.
//

#include "SettingInfo.h"

SettingInfo::SettingInfo()
{
    this->iMaxNumSpectra = 0;
    
    this->sWorkingDirectory = "";
    this->sConfigureFilePath = "";
    this->sOutputDirectory = "";
    this->sMode = "";
    this->sSpectraFilePath = "";
    this->sResultsFileName = "";
    this->sAnnotationFileName = "";
    this->bInternal = false;
    
    this->sMetaboliteDatabasePath = "";
    this->bPositiveDefaultPolarity = true;
    this->iDefaultChargeState = 1;
    this->dMassToleranceParentIon = 0.01;
    this->dMassToleranceFragmentIons = 0.01;
    this->bBreakRings = true;
    this->iFragmentationDepth = 3;
    this->iNumberofProcesses = 1;
    
    this->bGraphGrammar = false;
}

SettingInfo::~SettingInfo()
{
    size_t i;
    for (i = 0; i < vpGeneralGrammars.size(); i++)
    {
        delete vpGeneralGrammars.at(i);
        delete vpSpecialGrammars.at(i);
    }
}
